<?php

namespace Eater\Glim\Model\Map;

use Eater\Glim\Model\EmailAddress;
use Eater\Glim\Model\EmailAddressQuery;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\InstancePoolTrait;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\DataFetcher\DataFetcherInterface;
use Propel\Runtime\Exception\PropelException;
use Propel\Runtime\Map\RelationMap;
use Propel\Runtime\Map\TableMap;
use Propel\Runtime\Map\TableMapTrait;


/**
 * This class defines the structure of the 'email_address' table.
 *
 *
 *
 * This map class is used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 */
class EmailAddressTableMap extends TableMap
{
    use InstancePoolTrait;
    use TableMapTrait;

    /**
     * The (dot-path) name of this class
     */
    const CLASS_NAME = '.Map.EmailAddressTableMap';

    /**
     * The default database name for this class
     */
    const DATABASE_NAME = 'default';

    /**
     * The table name for this class
     */
    const TABLE_NAME = 'email_address';

    /**
     * The related Propel class for this table
     */
    const OM_CLASS = '\\Eater\\Glim\\Model\\EmailAddress';

    /**
     * A class that can be returned by this tableMap
     */
    const CLASS_DEFAULT = 'EmailAddress';

    /**
     * The total number of columns
     */
    const NUM_COLUMNS = 5;

    /**
     * The number of lazy-loaded columns
     */
    const NUM_LAZY_LOAD_COLUMNS = 0;

    /**
     * The number of columns to hydrate (NUM_COLUMNS - NUM_LAZY_LOAD_COLUMNS)
     */
    const NUM_HYDRATE_COLUMNS = 5;

    /**
     * the column name for the id field
     */
    const COL_ID = 'email_address.id';

    /**
     * the column name for the verified field
     */
    const COL_VERIFIED = 'email_address.verified';

    /**
     * the column name for the verification field
     */
    const COL_VERIFICATION = 'email_address.verification';

    /**
     * the column name for the address field
     */
    const COL_ADDRESS = 'email_address.address';

    /**
     * the column name for the owner field
     */
    const COL_OWNER = 'email_address.owner';

    /**
     * The default string format for model objects of the related table
     */
    const DEFAULT_STRING_FORMAT = 'YAML';

    /**
     * holds an array of fieldnames
     *
     * first dimension keys are the type constants
     * e.g. self::$fieldNames[self::TYPE_PHPNAME][0] = 'Id'
     */
    protected static $fieldNames = array (
        self::TYPE_PHPNAME       => array('Id', 'Verified', 'Verification', 'Address', 'Owner', ),
        self::TYPE_CAMELNAME     => array('id', 'verified', 'verification', 'address', 'owner', ),
        self::TYPE_COLNAME       => array(EmailAddressTableMap::COL_ID, EmailAddressTableMap::COL_VERIFIED, EmailAddressTableMap::COL_VERIFICATION, EmailAddressTableMap::COL_ADDRESS, EmailAddressTableMap::COL_OWNER, ),
        self::TYPE_FIELDNAME     => array('id', 'verified', 'verification', 'address', 'owner', ),
        self::TYPE_NUM           => array(0, 1, 2, 3, 4, )
    );

    /**
     * holds an array of keys for quick access to the fieldnames array
     *
     * first dimension keys are the type constants
     * e.g. self::$fieldKeys[self::TYPE_PHPNAME]['Id'] = 0
     */
    protected static $fieldKeys = array (
        self::TYPE_PHPNAME       => array('Id' => 0, 'Verified' => 1, 'Verification' => 2, 'Address' => 3, 'Owner' => 4, ),
        self::TYPE_CAMELNAME     => array('id' => 0, 'verified' => 1, 'verification' => 2, 'address' => 3, 'owner' => 4, ),
        self::TYPE_COLNAME       => array(EmailAddressTableMap::COL_ID => 0, EmailAddressTableMap::COL_VERIFIED => 1, EmailAddressTableMap::COL_VERIFICATION => 2, EmailAddressTableMap::COL_ADDRESS => 3, EmailAddressTableMap::COL_OWNER => 4, ),
        self::TYPE_FIELDNAME     => array('id' => 0, 'verified' => 1, 'verification' => 2, 'address' => 3, 'owner' => 4, ),
        self::TYPE_NUM           => array(0, 1, 2, 3, 4, )
    );

    /**
     * Initialize the table attributes and columns
     * Relations are not initialized by this method since they are lazy loaded
     *
     * @return void
     * @throws PropelException
     */
    public function initialize()
    {
        // attributes
        $this->setName('email_address');
        $this->setPhpName('EmailAddress');
        $this->setIdentifierQuoting(false);
        $this->setClassName('\\Eater\\Glim\\Model\\EmailAddress');
        $this->setPackage('');
        $this->setUseIdGenerator(true);
        // columns
        $this->addPrimaryKey('id', 'Id', 'INTEGER', true, null, null);
        $this->addColumn('verified', 'Verified', 'BOOLEAN', false, null, false);
        $this->addColumn('verification', 'Verification', 'VARCHAR', false, 64, null);
        $this->addColumn('address', 'Address', 'VARCHAR', false, 256, null);
        $this->addForeignKey('owner', 'Owner', 'INTEGER', 'user', 'id', false, null, null);
    } // initialize()

    /**
     * Build the RelationMap objects for this table relationships
     */
    public function buildRelations()
    {
        $this->addRelation('UserRelatedByOwner', '\\Eater\\Glim\\Model\\User', RelationMap::MANY_TO_ONE, array (
  0 =>
  array (
    0 => ':owner',
    1 => ':id',
  ),
), null, null, null, false);
        $this->addRelation('UserRelatedByEmail', '\\Eater\\Glim\\Model\\User', RelationMap::ONE_TO_MANY, array (
  0 =>
  array (
    0 => ':email',
    1 => ':id',
  ),
), null, null, 'UsersRelatedByEmail', false);
        $this->addRelation('EmailMessageRelatedByRecipient', '\\Eater\\Glim\\Model\\EmailMessage', RelationMap::ONE_TO_MANY, array (
  0 =>
  array (
    0 => ':recipient',
    1 => ':id',
  ),
), null, null, 'EmailMessagesRelatedByRecipient', false);
        $this->addRelation('EmailMessageRelatedBySender', '\\Eater\\Glim\\Model\\EmailMessage', RelationMap::ONE_TO_MANY, array (
  0 =>
  array (
    0 => ':sender',
    1 => ':id',
  ),
), null, null, 'EmailMessagesRelatedBySender', false);
    } // buildRelations()

    /**
     * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
     *
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, a serialize()d version of the primary key will be returned.
     *
     * @param array  $row       resultset row.
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM
     *
     * @return string The primary key hash of the row
     */
    public static function getPrimaryKeyHashFromRow($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {
        // If the PK cannot be derived from the row, return NULL.
        if ($row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)] === null) {
            return null;
        }

        return (string) $row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)];
    }

    /**
     * Retrieves the primary key from the DB resultset row
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, an array of the primary key columns will be returned.
     *
     * @param array  $row       resultset row.
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM
     *
     * @return mixed The primary key of the row
     */
    public static function getPrimaryKeyFromRow($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {
        return (int) $row[
            $indexType == TableMap::TYPE_NUM
                ? 0 + $offset
                : self::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)
        ];
    }

    /**
     * The class that the tableMap will make instances of.
     *
     * If $withPrefix is true, the returned path
     * uses a dot-path notation which is translated into a path
     * relative to a location on the PHP include_path.
     * (e.g. path.to.MyClass -> 'path/to/MyClass.php')
     *
     * @param boolean $withPrefix Whether or not to return the path with the class name
     * @return string path.to.ClassName
     */
    public static function getOMClass($withPrefix = true)
    {
        return $withPrefix ? EmailAddressTableMap::CLASS_DEFAULT : EmailAddressTableMap::OM_CLASS;
    }

    /**
     * Populates an object of the default type or an object that inherit from the default.
     *
     * @param array  $row       row returned by DataFetcher->fetch().
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType The index type of $row. Mostly DataFetcher->getIndexType().
                                 One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     * @return array           (EmailAddress object, last column rank)
     */
    public static function populateObject($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {
        $key = EmailAddressTableMap::getPrimaryKeyHashFromRow($row, $offset, $indexType);
        if (null !== ($obj = EmailAddressTableMap::getInstanceFromPool($key))) {
            // We no longer rehydrate the object, since this can cause data loss.
            // See http://www.propelorm.org/ticket/509
            // $obj->hydrate($row, $offset, true); // rehydrate
            $col = $offset + EmailAddressTableMap::NUM_HYDRATE_COLUMNS;
        } else {
            $cls = EmailAddressTableMap::OM_CLASS;
            /** @var EmailAddress $obj */
            $obj = new $cls();
            $col = $obj->hydrate($row, $offset, false, $indexType);
            EmailAddressTableMap::addInstanceToPool($obj, $key);
        }

        return array($obj, $col);
    }

    /**
     * The returned array will contain objects of the default type or
     * objects that inherit from the default.
     *
     * @param DataFetcherInterface $dataFetcher
     * @return array
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
    public static function populateObjects(DataFetcherInterface $dataFetcher)
    {
        $results = array();

        // set the class once to avoid overhead in the loop
        $cls = static::getOMClass(false);
        // populate the object(s)
        while ($row = $dataFetcher->fetch()) {
            $key = EmailAddressTableMap::getPrimaryKeyHashFromRow($row, 0, $dataFetcher->getIndexType());
            if (null !== ($obj = EmailAddressTableMap::getInstanceFromPool($key))) {
                // We no longer rehydrate the object, since this can cause data loss.
                // See http://www.propelorm.org/ticket/509
                // $obj->hydrate($row, 0, true); // rehydrate
                $results[] = $obj;
            } else {
                /** @var EmailAddress $obj */
                $obj = new $cls();
                $obj->hydrate($row);
                $results[] = $obj;
                EmailAddressTableMap::addInstanceToPool($obj, $key);
            } // if key exists
        }

        return $results;
    }
    /**
     * Add all the columns needed to create a new object.
     *
     * Note: any columns that were marked with lazyLoad="true" in the
     * XML schema will not be added to the select list and only loaded
     * on demand.
     *
     * @param Criteria $criteria object containing the columns to add.
     * @param string   $alias    optional table alias
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
    public static function addSelectColumns(Criteria $criteria, $alias = null)
    {
        if (null === $alias) {
            $criteria->addSelectColumn(EmailAddressTableMap::COL_ID);
            $criteria->addSelectColumn(EmailAddressTableMap::COL_VERIFIED);
            $criteria->addSelectColumn(EmailAddressTableMap::COL_VERIFICATION);
            $criteria->addSelectColumn(EmailAddressTableMap::COL_ADDRESS);
            $criteria->addSelectColumn(EmailAddressTableMap::COL_OWNER);
        } else {
            $criteria->addSelectColumn($alias . '.id');
            $criteria->addSelectColumn($alias . '.verified');
            $criteria->addSelectColumn($alias . '.verification');
            $criteria->addSelectColumn($alias . '.address');
            $criteria->addSelectColumn($alias . '.owner');
        }
    }

    /**
     * Returns the TableMap related to this object.
     * This method is not needed for general use but a specific application could have a need.
     * @return TableMap
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
    public static function getTableMap()
    {
        return Propel::getServiceContainer()->getDatabaseMap(EmailAddressTableMap::DATABASE_NAME)->getTable(EmailAddressTableMap::TABLE_NAME);
    }

    /**
     * Add a TableMap instance to the database for this tableMap class.
     */
    public static function buildTableMap()
    {
        $dbMap = Propel::getServiceContainer()->getDatabaseMap(EmailAddressTableMap::DATABASE_NAME);
        if (!$dbMap->hasTable(EmailAddressTableMap::TABLE_NAME)) {
            $dbMap->addTableObject(new EmailAddressTableMap());
        }
    }

    /**
     * Performs a DELETE on the database, given a EmailAddress or Criteria object OR a primary key value.
     *
     * @param mixed               $values Criteria or EmailAddress object or primary key or array of primary keys
     *              which is used to create the DELETE statement
     * @param  ConnectionInterface $con the connection to use
     * @return int             The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *                         if supported by native driver or if emulated using Propel.
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
     public static function doDelete($values, ConnectionInterface $con = null)
     {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(EmailAddressTableMap::DATABASE_NAME);
        }

        if ($values instanceof Criteria) {
            // rename for clarity
            $criteria = $values;
        } elseif ($values instanceof \Eater\Glim\Model\EmailAddress) { // it's a model object
            // create criteria based on pk values
            $criteria = $values->buildPkeyCriteria();
        } else { // it's a primary key, or an array of pks
            $criteria = new Criteria(EmailAddressTableMap::DATABASE_NAME);
            $criteria->add(EmailAddressTableMap::COL_ID, (array) $values, Criteria::IN);
        }

        $query = EmailAddressQuery::create()->mergeWith($criteria);

        if ($values instanceof Criteria) {
            EmailAddressTableMap::clearInstancePool();
        } elseif (!is_object($values)) { // it's a primary key, or an array of pks
            foreach ((array) $values as $singleval) {
                EmailAddressTableMap::removeInstanceFromPool($singleval);
            }
        }

        return $query->delete($con);
    }

    /**
     * Deletes all rows from the email_address table.
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).
     */
    public static function doDeleteAll(ConnectionInterface $con = null)
    {
        return EmailAddressQuery::create()->doDeleteAll($con);
    }

    /**
     * Performs an INSERT on the database, given a EmailAddress or Criteria object.
     *
     * @param mixed               $criteria Criteria or EmailAddress object containing data that is used to create the INSERT statement.
     * @param ConnectionInterface $con the ConnectionInterface connection to use
     * @return mixed           The new primary key.
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
    public static function doInsert($criteria, ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(EmailAddressTableMap::DATABASE_NAME);
        }

        if ($criteria instanceof Criteria) {
            $criteria = clone $criteria; // rename for clarity
        } else {
            $criteria = $criteria->buildCriteria(); // build Criteria from EmailAddress object
        }

        if ($criteria->containsKey(EmailAddressTableMap::COL_ID) && $criteria->keyContainsValue(EmailAddressTableMap::COL_ID) ) {
            throw new PropelException('Cannot insert a value for auto-increment primary key ('.EmailAddressTableMap::COL_ID.')');
        }


        // Set the correct dbName
        $query = EmailAddressQuery::create()->mergeWith($criteria);

        // use transaction because $criteria could contain info
        // for more than one table (I guess, conceivably)
        return $con->transaction(function () use ($con, $query) {
            return $query->doInsert($con);
        });
    }

} // EmailAddressTableMap
// This is the static code needed to register the TableMap for this table with the main Propel class.
//
EmailAddressTableMap::buildTableMap();
